/* C-Programm "hohlwelle.c" zur Berechnung der */
/* Biegelinie einer mit einem Festlager und einem */
/* Loslager gelagerten Hohlwelle */
/* Fischer, 02.10.91, Stand 02.10.91 */

#include <stdio.h>
#include <math.h>
#define pi 3.1415265

main ()
{
 float da,di,emod,l,a,b,f,itraeg,step,x,x_max,w_x,w_a,w_max;
 int nz,i;

 printf("*******************************************\n");
 printf("* Durchbiegung einer mit einem Festlager  *\n");
 printf("* und einem Loslager gelagerten Hohlwelle *\n");
 printf("*******************************************\n");

 printf("\nAussendurchmesser [mm]    : ");
 scanf("%f",&da);
 printf("\nInnendurchmesser [mm]     : ");
 scanf("%f",&di);
 printf("\nE-Modul [N/mm^2}          : ");
 scanf("%f",&emod);
 printf("\nLagerabstand [mm]         : ");
 scanf("%f",&l);
 printf("\nKraft [N]                 : ");
 scanf("%f",&f);
 printf("\nKraftangriff bei x = [mm] : ");
 scanf("%f",&a);
 printf("\nAnzahl Zwischenpunkte     : ");
 scanf("%d",&nz);

 b=l-a;
 itraeg=pi*(da*da*da*da-di*di*di*di)/64;
 printf("\n\nFlaechentraegheitsmoment [mm^4]           : %6.0f\n",itraeg);

 w_a = f*a*a*b*b/3/emod/itraeg/l;
 printf("Durchbiegung am Kraftangriffspunkt [mm]   : %6.4f\n",w_a);

 if(a>b)
  {
   x_max=sqrt((l*l-b*b)/3);
   w_max=f*b*sqrt((l*l-b*b)*(l*l-b*b)*(l*l-b*b))/15.59/emod/itraeg/l;
  }
 else
  {
   x_max=l-sqrt((l*l-a*a)/3);
   w_max=f*a*sqrt((l*l-a*a)*(l*l-a*a)*(l*l-a*a))/15.59/emod/itraeg/l;
 }

 printf("Ort der maximalen Durchbiegung x_max [mm] : %6.1f\n",x_max);
 printf("Maximale Durchbiegung w_max [mm]          : %6.4f\n",w_max);

 step=l/((float)nz+1);


 printf("\nZwischenwerte:\n\n");
 printf("  x [mm]    Durchbiegung [mm]\n");
 printf("--------    -----------------\n");
 for(i=0; i<=(nz+1); i++)
  {
   x = (float)i*step;
    if((a<=0.001)||((l-a)<0.001))
     w_x = 0;
    else if(x<a)
     w_x=f*a*b*b/6/emod/itraeg*((1+l/b)*x/l-x*x*x/a/b/l);
    else
     w_x=f*a*a*b/6/emod/itraeg*((1+l/a)*(l-x)/l-(l-x)*(l-x)*(l-x)/a/b/l);
    printf("%8.1f    %6.4f\n",x,w_x);
 }

}
